/*
 * Licensed Materials - Property of IBM pidnumber (C) Copyright IBM Corporation
 * 2005. All Rights Reserved. US Government Users Restricted Rights- Use,
 * duplication or disclosure restricted by GSA ADP Schedule Contract with IBM
 * Corp.
 */
package com.ibm.j2ca.sample.twineball.emd.discovery.connection;

import com.ibm.j2ca.extension.emd.PropertyNameHelper;
import com.ibm.j2ca.extension.emd.discovery.WBIAdapterTypeImpl;
import com.ibm.j2ca.extension.emd.discovery.WBIMetadataDiscoveryImpl;
import com.ibm.j2ca.extension.emd.discovery.connection.WBIInboundConnectionTypeImpl;
import com.ibm.j2ca.extension.emd.internal.DisplayNameHelper;
import com.ibm.j2ca.extension.logging.LogUtils;

import commonj.connector.metadata.MetadataException;
import commonj.connector.metadata.discovery.connection.InboundConnectionConfiguration;

/**
 * This is the connectionType for inbound.
 */
public class TwineBallInboundConnectionType extends WBIInboundConnectionTypeImpl {
    TwineBallInboundConnectionConfiguration conf = null;
    LogUtils logUtils;
    PropertyNameHelper helper;

    public TwineBallInboundConnectionType(WBIAdapterTypeImpl adapterType,PropertyNameHelper helper) throws MetadataException {
        super(adapterType, helper);
        logUtils = helper.getLogUtils();
        this.helper = helper;
        setDescription(helper.getPropertyDescription("ConnectionType"));
        setId("TwineBall");
        setDisplayName(helper.getPropertyName("ConnectionType"));
    }

    /*
     * (non-Javadoc)
     *
     * @see commonj.connector.metadata.discovery.connection.InboundConnectionType#createInboundConnectionConfiguration()
     */
    public InboundConnectionConfiguration createInboundConnectionConfiguration() {
        try {
            if (conf == null){
            	if(helper!= null){
            		 conf = new TwineBallInboundConnectionConfiguration(this,helper);
            	}
            }
        } catch (MetadataException e) {
           throw new RuntimeException(e);
        }
        return conf;
    }
}