package com.ibm.j2ca.sample.twineball.emd.runtime;

import javax.resource.cci.Record;

import com.ibm.j2ca.base.WBIInteractionSpec;
import com.ibm.j2ca.base.internal.WPSServiceHelper;
import com.ibm.j2ca.extension.dataexchange.sdo.DEFactorySDO;
import com.ibm.j2ca.sample.twineball.TwineBallStructuredRecord;
import commonj.connector.runtime.DataBindingException;
import commonj.connector.runtime.RecordHolderDataBinding;
import commonj.sdo.DataObject;
import commonj.sdo.Property;

public abstract class TwineBallDataBinding implements RecordHolderDataBinding {

	TwineBallStructuredRecord record;
	DataObject inputBG = null;
	DataObject container = null;

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.RecordHolderDataBinding#getRecord()
	 */
	public Record getRecord() throws DataBindingException {
		// TODO Auto-generated method stub
		return record;
	}

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.RecordHolderDataBinding#setRecord(javax.resource.cci.Record)
	 */
	public void setRecord(Record arg0) throws DataBindingException {
		// TODO Auto-generated method stub
		this.record = (TwineBallStructuredRecord) arg0;
	}

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.DataBinding#getDataObject()
	 */
    public DataObject getDataObject() throws DataBindingException 
    {
       	// TODO Auto-generated method stub
       	DataObject returnValue = null;
        	
       	try 
        {
            String bgname = this.getBusinessObjectName();
            String url = this.getNamespaceURI();
	    System.out.println(url + " " + bgname);

            DEFactorySDO binding = new DEFactorySDO();

            DataObject dataObject = WPSServiceHelper.createBusinessObject(url, bgname);

            String operation = record.getOperationName();

            if (operation.equals(WBIInteractionSpec.RETRIEVE_ALL_OP))
            {
                DataObject returnObject = dataObject;
                System.out.println("in retrieve all:  container " + returnObject);

                // createBusinessObject always ensures we get a non BG
                Property p = (Property) returnObject.getType().getProperties().get(0);
                dataObject = WPSServiceHelper.createBusinessObject(p.getType().getURI(), p.getType().getName());
		System.out.println("in retrieve all:  data object " + dataObject);

                boolean isBG = WPSServiceHelper.isBusinessGraph(returnObject);
                if (isBG)
                {
                    dataObject = dataObject.createDataObject(WPSServiceHelper.getRootBusinessObjectProperty(dataObject.getType()));
                }

                record.initializeOutput(binding, dataObject);

                boolean havesome = false;
                while (record.getNext(true))
                {
                    havesome = true;
                    DataObject object = (DataObject) binding.getBoundObject();
        	    System.out.println("in retrieve all, afterGetNext:  data object " + object);
                    if (dataObject.getContainer() != null)
                    {
                        DataObject BG = WPSServiceHelper.createDataObject(object.getType().getURI()+ "bg", object.getType().getName()+"BG"); //$NON-NLS-1$ //$NON-NLS-2$
                        BG.set(WPSServiceHelper.getRootBusinessObjectProperty(BG.getType()), object);
                        returnObject.getList(0).add(BG);
                    }
                    else
                    {
                        returnObject.getList(0).add(object);
                    }
                }

                // get last one...
                if (havesome)
                {
                    DataObject object = (DataObject) binding.getBoundObject();
        	    System.out.println("in retrieve all, get last object:  data object " + object);
                    if (dataObject.getContainer() != null)
                    {
                        DataObject BG = WPSServiceHelper.createDataObject(object.getType().getURI()+ "bg", object.getType().getName()+"BG"); //$NON-NLS-1$ //$NON-NLS-2$
                        BG.set(WPSServiceHelper.getRootBusinessObjectProperty(BG.getType()), object);
                        returnObject.getList(0).add(BG);
                    }
                    else
                    {
                        returnObject.getList(0).add(object);
                    }
                }

                return returnObject;
            }

            // NOT RetrieveAll...
            record.initializeOutput(binding, dataObject);
            record.getNext(true);
            DataObject object = (DataObject) binding.getBoundObject();
            DataObject bg = dataObject.getContainer();
            if (bg != null)
            {
                returnValue = WPSServiceHelper.createDataObject(bg.getType().getURI(), bg.getType().getName());
                returnValue.set(WPSServiceHelper.getRootBusinessObjectProperty(returnValue.getType()), object);
                //CR 70325, 70491 - set verb if operations are Create, Update or Delete
                if (operation.equalsIgnoreCase(WBIInteractionSpec.CREATE_OP))
                {
                    returnValue.set("verb","Create");//$NON-NLS-1$  //$NON-NLS-2$
                }
                else if (operation.equalsIgnoreCase(WBIInteractionSpec.UPDATE_OP))
                {
                    returnValue.set("verb","Update");//$NON-NLS-1$  //$NON-NLS-2$
                }
                else if (operation.equalsIgnoreCase(WBIInteractionSpec.DELETE_OP))
                {
                    returnValue.set("verb","Delete");//$NON-NLS-1$  //$NON-NLS-2$
                }
            }
            else
            {
                returnValue = object;
            }
	    System.out.println("binding object " + binding.getBoundObject());
        }
        catch (Exception e)
        {
            e.printStackTrace();
            throw new DataBindingException("Failed in population return object", e);
        }
        return returnValue;
    }

	/* (non-Javadoc)
	 * @see commonj.connector.runtime.DataBinding#setDataObject(commonj.sdo.DataObject)
	 */
    public void setDataObject(DataObject arg0) throws DataBindingException {
        // TODO Auto-generated method stub
        try
        {
            record = new TwineBallStructuredRecord();
            DEFactorySDO binding = new DEFactorySDO();
            DataObject dataObject = null;
            
            if (arg0.getType().getName().indexOf("Container") != -1)
            {
                // We should only see a Container for a 3 arg execute call for the output record - for RetrieveAll, so get BG or Primary SDO
                Property p = (Property) arg0.getType().getProperties().get(0);
                java.util.List bgList = arg0.getList(p);
                if (bgList != null && !bgList.isEmpty())
                {
                    dataObject = (DataObject)bgList.get(0);
                }
            }
            else
            {
                dataObject = arg0;
            }

            boolean isBG = WPSServiceHelper.isBusinessGraph(dataObject);
            if (isBG)
            {
                DataObject regRootBusObj = dataObject.getDataObject(WPSServiceHelper.getRootBusinessObjectProperty(dataObject.getType()));
                dataObject = WPSServiceHelper.getRootBusinessObjectInstance(dataObject);

                if (dataObject != null && regRootBusObj == null)  // If parent level delete via CS (ApplyChanges)
                    record.setApplyChangesParentDelete(true);

                String verb = null;
                verb = arg0.getString("verb");
                if (verb != null)
                    record.setOperationName(verb);
            }

            binding.setBoundObject(dataObject);
            if (dataObject != null) // Assume a null dataObject indicates our output record on a 3 arg execute, so don't initialize.
            {
                inputBG = arg0;
                record.initializeInput(binding, dataObject);    
            }
        }
        catch (Exception e)
        {
            System.out.println(e.toString());
            throw new DataBindingException("Failed to initialize cursor", e); 
        }
    }
	
	public abstract String getNamespaceURI();

	public abstract String getBusinessObjectName();

}
